<script lang="ts">
  import { createEventDispatcher } from "svelte";

  import {
    isActive,
    isSpeaking,
    passingPrice,
    sortedByValue,
    withUserLast,
  } from "../utils";
  import BidActionForm from "./BidActionForm.svelte";
  import Cash from "./Cash.svelte";
  import PropertyCard from "./PropertyCard.svelte";
  import PropertyCardInline from "./PropertyCardInline.svelte";
  import SaleCards from "./SaleCards.svelte";
  import Speech from "./Speech.svelte";
  const dispatch = createEventDispatcher();

  function dispatchAction(action: Action): void {
    dispatch("action", action);
  }

  export let user: Player | null;
  export let player: Player;
  export let state: GameState;

  $: orderedPlayers = withUserLast(state.players, user?.id);

  function getPlayerTransform(playerIndex: number, playerCount: number) {
    const angleStep = -(2 * Math.PI) / playerCount;
    const startingAngle = 1.5 * Math.PI + angleStep;
    const angle = startingAngle + angleStep * playerIndex;

    const x = Math.cos(angle) * 20; //.toFixed(2) + "em";
    const y = -(Math.sin(angle) * 20); // .toFixed(2) + "em";

    const xAlignment =
      x < -1
        ? "translateX(-100%)"
        : x > 1
        ? "translateX(0)"
        : "translateX(-50%)";

    const yAlignment =
      y < -1
        ? "translateY(-100%)"
        : y > 1
        ? "translateY(0)"
        : "translateY(-50%)";

    return `
      ${xAlignment}
      ${yAlignment}
      translate(${x.toFixed(2)}rem, ${y.toFixed(2)}rem)
    `;
  }

  function getCardTransform(cardIndex: number, cardCount: number) {
    const angleStep = 3;
    const startAngle = (cardCount - 1) * (-angleStep / 2);
    const angle = startAngle + cardIndex * angleStep;
    return `rotate(${angle}deg)`;
  }

  function getPlayerBid(playerId: PlayerId): number {
    if (state.phase.name === "buying") {
      return state.phase.bids[playerId] ?? 0;
    } else {
      return NaN;
    }
  }
</script>

<div
  class="player"
  class:user={player.id === user?.id}
  style={`transform: ${getPlayerTransform(
    orderedPlayers.findIndex((p) => p.id === player.id),
    state.players.length
  )};`}
>
  <div class="player-cards">
    {#each sortedByValue(player.cards) as card, cardIndex (card)}
      <div
        class="card-button-wrapper"
        style={`
        position: absolute;
        left: 50%;
        top: 0;
        transform:
          translate(-50%, -75%)
          translateY(500%)
          ${getCardTransform(cardIndex, player.cards.length)}
          translateY(-500%);
        transition: transform 0.5s;
        `}
      >
        <button
          class="card-button"
          disabled={state.phase.name !== "selling" ||
            user?.id !== player.id ||
            !isActive(state.phase, player.id)}
          on:click={() => dispatchAction({ name: "sell", card })}
        >
          <PropertyCard {card} facedown={user?.id !== player.id} />
        </button>
      </div>
    {/each}
  </div>

  <gs6-player-box
    userid={player.id}
    active={isActive(state.phase, player.id)}
    speaking={isSpeaking(state.phase, player.id)}
  >
    {#if player.id === user?.id}
      <div class="player-cash">
        <Cash cash={player.cash} />
      </div>
    {/if}

    {#if isSpeaking(state.phase, player.id)}
      <div slot="speech">
        {#if state.phase.name === "buying" || state.phase.name === "buyingComplete"}
          <Speech purchase={state.phase.purchases[player.id]} />
        {/if}
      </div>
    {/if}

    {#if state.phase.name === "buying" && user && user.id === player.id && isActive(state.phase, user.id)}
      <div class="player-action-left">
        <div>
          Buy house
          <PropertyCardInline card={Math.min(...state.phase.properties)} />
          <br />
          for
          <Cash cash={passingPrice(getPlayerBid(player.id))} />
        </div>
        <button
          class="secondary"
          on:click={() => dispatchAction({ name: "pass" })}>Buy it</button
        >
      </div>
      <div class="player-action-right">
        <BidActionForm
          players={state.players}
          phase={state.phase}
          {user}
          on:action
        />
      </div>
    {:else if state.phase.name === "selling" && user && user.id === player.id && isActive(state.phase, user.id)}
      <div class="player-action-right-center">
        <em>↖ Select a house to sell.</em>
      </div>
    {:else if (state.phase.name === "sellingComplete" || state.phase.name === "buyingComplete") && user?.id === player.id && isActive(state.phase, user?.id)}
      <div class="player-action-right-center">
        <button
          class="primary"
          on:click={() => dispatchAction({ name: "ready" })}>I'm ready!</button
        >
      </div>
    {/if}

    {#if state.phase.name === "selling" && state.phase.sale[player.id]}
      <div class="player-selected-card">
        <PropertyCard
          card={state.phase.sale[player.id]}
          facedown={player.id !== user?.id}
        />
      </div>
    {/if}

    {#if player.sales}
      <div class="player-sales">
        {#each player.sales as [property, currency]}
          <div>
            {#if player.id === user?.id || state.phase.name === "gameComplete"}
              <SaleCards {property} {currency} />
            {/if}
          </div>
        {/each}
      </div>
    {/if}
  </gs6-player-box>

  {#if getPlayerBid(player.id) > 0}
    <div class="previous-bid panel">
      <div>
        <span class="bid-label">Bid:</span>
        <Cash cash={getPlayerBid(player.id)} />
      </div>
    </div>
  {/if}
</div>

<style>
  .player {
    position: absolute;
    top: 50%;
    left: 50%;
    transition: transform 0.5s;
  }
  .player-selected-card {
    font-size: 0.67em;
    position: absolute;
    bottom: 0;
    right: 0;
    transform: translate(100%, 0) rotate(15deg);
  }
  .user .player-selected-card {
    font-size: 0.8em;
  }

  .player-cash {
    text-align: center;
  }

  .player:hover {
    z-index: 9999;
  }

  .player-cards {
    font-size: 0.75em;
  }
  .user .player-cards {
    font-size: 1.2em;
  }
  .player-sales {
    font-size: 0.8em;
    position: absolute;
    bottom: 0;
    left: 50%;
    transform: translate(-50%, 100%) translateY(-0.5em);

    display: flex;
  }

  .player-sales > * {
    margin-left: -1.5em;
    margin-right: -1.5em;
  }

  .card-button {
    padding: 0;
    border: none;
    font-size: inherit;
    color: inherit;
    background: none;
    text-align: inherit;
    transition: transform 0.2s ease-in-out;
  }
  .card-button:not(:disabled):hover,
  .card-button:not(:disabled):focus {
    cursor: pointer;
    transform: translateY(-25%);
  }

  .player-action-left {
    width: 15em;
    position: absolute;
    bottom: 0;
    left: 0;
    transform: translateX(-100%) translateX(-0.5rem);
    text-align: right;

    display: flex;
    flex-direction: column;
    align-items: flex-end;
    gap: 0.125em;
  }
  .player-action-right {
    width: 15em;
    position: absolute;
    bottom: 0;
    right: 0;
    transform: translateX(100%) translateX(0.5rem);
  }
  .player-action-right-center {
    width: 15em;
    position: absolute;
    top: 50%;
    right: 0;
    transform: translate(100%, -50%) translateX(0.5rem);
  }

  .previous-bid {
    position: absolute;
    left: 50%;
    top: calc(100% - 0.33rem);

    text-align: center;
    transform: translateX(-50%);
    padding: 0.5rem 1rem;
  }
  .bid-label {
    font-weight: 500;
  }
  .previous-bid > div {
    position: relative;
    display: flex;
    gap: 0.5em;
  }
</style>
